#include <windows.h>
#include <stdio.h>

typedef int NTSTATUS;

int ServiceStart;

__declspec(dllexport) NTSTATUS SampleService0(void)
{
	_asm {
		mov eax, ServiceStart
		int 2eh
	}
}

__declspec(dllexport) NTSTATUS SampleService1(int param)
{
	void **stackframe=&param;

	_asm {
		mov eax, ServiceStart
		add eax, 1
		mov edx, stackframe
		int 2eh
	}
}

__declspec(dllexport) NTSTATUS SampleService2(int param1, int param2)
{
	char **stackframe=&param1;

	_asm {
		mov eax, ServiceStart
		add eax, 2
		mov edx, stackframe
		int 2eh
	}
}

__declspec(dllexport) NTSTATUS SampleService3(int param1, int param2,
				   int param3)
{
	char **stackframe=&param1;

	_asm {
		mov eax, ServiceStart
		add eax, 3
		mov edx, stackframe
		int 2eh
	}

}

__declspec(dllexport) NTSTATUS SampleService4(int param1, int param2,
				   int param3, int param4)
	   
{
	char **stackframe=&param1;

	_asm {
		mov eax, ServiceStart
		add eax, 4
		mov edx, stackframe
		int 2eh
	}

}

__declspec(dllexport) NTSTATUS SampleService5(int param1, int param2,
				   int param3, int param4, 
				   int param5)
   
{
	char **stackframe=&param1;

	_asm {
		mov eax, ServiceStart
		add eax, 5
		mov edx, stackframe
		int 2eh
	}

}

__declspec(dllexport) NTSTATUS SampleService6(int param1, int param2,
				   int param3, int param4, 
				   int param5, int param6)
   
{
	char **stackframe=&param1;

	_asm {
		mov eax, ServiceStart
		add eax, 6
		mov edx, stackframe
		int 2eh
	}
}


BOOL WINAPI DllMain(HANDLE hModule, DWORD Reason, LPVOID lpReserved)
{
    switch (Reason) {
	OSVERSIONINFO VersionInfo;


    case DLL_PROCESS_ATTACH:

        //
        // We're being loaded - save our handle
        //
		VersionInfo.dwOSVersionInfoSize=sizeof(VersionInfo);
		if (GetVersionEx(&VersionInfo)==FALSE)
			return FALSE;
		if (VersionInfo.dwMajorVersion==3)
			ServiceStart=0xC4;
		else if (VersionInfo.dwMajorVersion==4)
			ServiceStart=0xD2;
		else {
			Beep(1000, 2000);
			return FALSE;
		}

       	return	TRUE;

    default:
        return TRUE;
    }

}
